---
title: Get unified host facet info
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > CSM Settings
---

# Get unified host facet info{% #get-unified-host-facet-info %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and may be subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                           |
| ----------------- | ---------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/csm/settings/hosts/facet_info |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/csm/settings/hosts/facet_info |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/csm/settings/hosts/facet_info      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/csm/settings/hosts/facet_info      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/csm/settings/hosts/facet_info  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/csm/settings/hosts/facet_info     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/csm/settings/hosts/facet_info |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/csm/settings/hosts/facet_info |

### Overview

Get the value distribution for a specific unified host facet, with optional search and filtering.

### Arguments

#### Query Strings

| Name                    | Type   | Description                                                                                                                                                                                                                                                                                                                                                                                  |
| ----------------------- | ------ | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| facet [*required*] | string | The facet identifier to retrieve value distribution for. Valid values include `resource_name`, `account_id`, `resource_type`, `cloud_provider`, `agentless_vulnerability_scanning`, `agentless_posture_management`, `hostname`, `agent_version`, `os`, `cluster_name`, `agent_posture_management`, `agent_cws_enabled`, `agent_csm_vm_hosts_enabled`, and `agent_csm_vm_containers_enabled`. |
| search                  | string | A search string to filter the facet values.                                                                                                                                                                                                                                                                                                                                                  |
| query                   | string | A filter query to scope the facet value counts.                                                                                                                                                                                                                                                                                                                                              |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response returned when requesting value distribution for a specific facet.

| Parent field | Field                         | Type     | Description                                                                                                            |
| ------------ | ----------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object   | The data wrapper for a facet info response.                                                                            |
| data         | attributes [*required*]  | object   | Attributes of a facet info response, containing the value distribution for the requested facet.                        |
| attributes   | items [*required*]       | [object] | The list of facet value entries for the current page.                                                                  |
| items        | count [*required*]       | int64    | The number of resources with this facet value.                                                                         |
| items        | value [*required*]       | string   | The facet value.                                                                                                       |
| data         | id [*required*]          | string   | The identifier of the facet.                                                                                           |
| data         | meta [*required*]        | object   | Metadata for the facet info response.                                                                                  |
| meta         | total_count [*required*] | int64    | The total number of distinct values for this facet.                                                                    |
| data         | type [*required*]        | enum     | The JSON:API type for facet info resources. The value should always be `facet_info`. Allowed enum values: `facet_info` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "items": [
        {
          "count": 100,
          "value": "aws"
        }
      ]
    },
    "id": "cloud_provider",
    "meta": {
      "total_count": 4
    },
    "type": "facet_info"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Required query arguments export facet="cloud_provider" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/csm/settings/hosts/facet_info?facet=${facet}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get unified host facet info returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.csm_settings_api import CSMSettingsApi

configuration = Configuration()
configuration.unstable_operations["get_csm_unified_host_facet_info"] = True
with ApiClient(configuration) as api_client:
    api_instance = CSMSettingsApi(api_client)
    response = api_instance.get_csm_unified_host_facet_info(
        facet="cloud_provider",
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Get unified host facet info returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.get_csm_unified_host_facet_info".to_sym] = true
end
api_instance = DatadogAPIClient::V2::CSMSettingsAPI.new
p api_instance.get_csm_unified_host_facet_info("cloud_provider")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Get unified host facet info returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.GetCSMUnifiedHostFacetInfo", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCSMSettingsApi(apiClient)
	resp, r, err := api.GetCSMUnifiedHostFacetInfo(ctx, "cloud_provider", *datadogV2.NewGetCSMUnifiedHostFacetInfoOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CSMSettingsApi.GetCSMUnifiedHostFacetInfo`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CSMSettingsApi.GetCSMUnifiedHostFacetInfo`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Get unified host facet info returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CsmSettingsApi;
import com.datadog.api.client.v2.model.CsmHostFacetInfoResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.getCSMUnifiedHostFacetInfo", true);
    CsmSettingsApi apiInstance = new CsmSettingsApi(defaultClient);

    try {
      CsmHostFacetInfoResponse result = apiInstance.getCSMUnifiedHostFacetInfo("cloud_provider");
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CsmSettingsApi#getCSMUnifiedHostFacetInfo");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Get unified host facet info returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_csm_settings::CSMSettingsAPI;
use datadog_api_client::datadogV2::api_csm_settings::GetCSMUnifiedHostFacetInfoOptionalParams;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.GetCSMUnifiedHostFacetInfo", true);
    let api = CSMSettingsAPI::with_config(configuration);
    let resp = api
        .get_csm_unified_host_facet_info(
            "cloud_provider".to_string(),
            GetCSMUnifiedHostFacetInfoOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Get unified host facet info returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.getCSMUnifiedHostFacetInfo"] = true;
const apiInstance = new v2.CSMSettingsApi(configuration);

const params: v2.CSMSettingsApiGetCSMUnifiedHostFacetInfoRequest = {
  facet: "cloud_provider",
};

apiInstance
  .getCSMUnifiedHostFacetInfo(params)
  .then((data: v2.CsmHostFacetInfoResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
